// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: device.proto

#ifndef PROTOBUF_device_2eproto__INCLUDED
#define PROTOBUF_device_2eproto__INCLUDED

#include <string>

#include <google/protobuf/stubs/common.h>

#if GOOGLE_PROTOBUF_VERSION < 3005000
#error This file was generated by a newer version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please update
#error your headers.
#endif
#if 3005000 < GOOGLE_PROTOBUF_MIN_PROTOC_VERSION
#error This file was generated by an older version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please
#error regenerate this file with a newer version of protoc.
#endif

#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/arena.h>
#include <google/protobuf/arenastring.h>
#include <google/protobuf/generated_message_table_driven.h>
#include <google/protobuf/generated_message_util.h>
#include <google/protobuf/metadata.h>
#include <google/protobuf/message.h>
#include <google/protobuf/repeated_field.h>  // IWYU pragma: export
#include <google/protobuf/extension_set.h>  // IWYU pragma: export
#include <google/protobuf/map.h>  // IWYU pragma: export
#include <google/protobuf/map_entry.h>
#include <google/protobuf/map_field_inl.h>
#include <google/protobuf/unknown_field_set.h>
#include "tango_enums.pb.h"
// @@protoc_insertion_point(includes)

namespace protobuf_device_2eproto {
// Internal implementation detail -- do not use these members.
struct TableStruct {
  static const ::google::protobuf::internal::ParseTableField entries[];
  static const ::google::protobuf::internal::AuxillaryParseTableField aux[];
  static const ::google::protobuf::internal::ParseTable schema[8];
  static const ::google::protobuf::internal::FieldMetadata field_metadata[];
  static const ::google::protobuf::internal::SerializationTable serialization_table[];
  static const ::google::protobuf::uint32 offsets[];
};
void AddDescriptors();
void InitDefaultsGetAttributeListMessageImpl();
void InitDefaultsGetAttributeListMessage();
void InitDefaultsGetCommandListMessageImpl();
void InitDefaultsGetCommandListMessage();
void InitDefaultsDeviceAttributeDescriptionImpl();
void InitDefaultsDeviceAttributeDescription();
void InitDefaultsAttributeListReplyImpl();
void InitDefaultsAttributeListReply();
void InitDefaultsDeviceCommandDescription_ParametersEntry_DoNotUseImpl();
void InitDefaultsDeviceCommandDescription_ParametersEntry_DoNotUse();
void InitDefaultsDeviceCommandDescription_ReturnValuesEntry_DoNotUseImpl();
void InitDefaultsDeviceCommandDescription_ReturnValuesEntry_DoNotUse();
void InitDefaultsDeviceCommandDescriptionImpl();
void InitDefaultsDeviceCommandDescription();
void InitDefaultsCommandListReplyImpl();
void InitDefaultsCommandListReply();
inline void InitDefaults() {
  InitDefaultsGetAttributeListMessage();
  InitDefaultsGetCommandListMessage();
  InitDefaultsDeviceAttributeDescription();
  InitDefaultsAttributeListReply();
  InitDefaultsDeviceCommandDescription_ParametersEntry_DoNotUse();
  InitDefaultsDeviceCommandDescription_ReturnValuesEntry_DoNotUse();
  InitDefaultsDeviceCommandDescription();
  InitDefaultsCommandListReply();
}
}  // namespace protobuf_device_2eproto
namespace mascot {
class AttributeListReply;
class AttributeListReplyDefaultTypeInternal;
extern AttributeListReplyDefaultTypeInternal _AttributeListReply_default_instance_;
class CommandListReply;
class CommandListReplyDefaultTypeInternal;
extern CommandListReplyDefaultTypeInternal _CommandListReply_default_instance_;
class DeviceAttributeDescription;
class DeviceAttributeDescriptionDefaultTypeInternal;
extern DeviceAttributeDescriptionDefaultTypeInternal _DeviceAttributeDescription_default_instance_;
class DeviceCommandDescription;
class DeviceCommandDescriptionDefaultTypeInternal;
extern DeviceCommandDescriptionDefaultTypeInternal _DeviceCommandDescription_default_instance_;
class DeviceCommandDescription_ParametersEntry_DoNotUse;
class DeviceCommandDescription_ParametersEntry_DoNotUseDefaultTypeInternal;
extern DeviceCommandDescription_ParametersEntry_DoNotUseDefaultTypeInternal _DeviceCommandDescription_ParametersEntry_DoNotUse_default_instance_;
class DeviceCommandDescription_ReturnValuesEntry_DoNotUse;
class DeviceCommandDescription_ReturnValuesEntry_DoNotUseDefaultTypeInternal;
extern DeviceCommandDescription_ReturnValuesEntry_DoNotUseDefaultTypeInternal _DeviceCommandDescription_ReturnValuesEntry_DoNotUse_default_instance_;
class GetAttributeListMessage;
class GetAttributeListMessageDefaultTypeInternal;
extern GetAttributeListMessageDefaultTypeInternal _GetAttributeListMessage_default_instance_;
class GetCommandListMessage;
class GetCommandListMessageDefaultTypeInternal;
extern GetCommandListMessageDefaultTypeInternal _GetCommandListMessage_default_instance_;
}  // namespace mascot
namespace mascot {

// ===================================================================

class GetAttributeListMessage : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.GetAttributeListMessage) */ {
 public:
  GetAttributeListMessage();
  virtual ~GetAttributeListMessage();

  GetAttributeListMessage(const GetAttributeListMessage& from);

  inline GetAttributeListMessage& operator=(const GetAttributeListMessage& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  GetAttributeListMessage(GetAttributeListMessage&& from) noexcept
    : GetAttributeListMessage() {
    *this = ::std::move(from);
  }

  inline GetAttributeListMessage& operator=(GetAttributeListMessage&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const GetAttributeListMessage& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const GetAttributeListMessage* internal_default_instance() {
    return reinterpret_cast<const GetAttributeListMessage*>(
               &_GetAttributeListMessage_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    0;

  void Swap(GetAttributeListMessage* other);
  friend void swap(GetAttributeListMessage& a, GetAttributeListMessage& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline GetAttributeListMessage* New() const PROTOBUF_FINAL { return New(NULL); }

  GetAttributeListMessage* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const GetAttributeListMessage& from);
  void MergeFrom(const GetAttributeListMessage& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(GetAttributeListMessage* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // @@protoc_insertion_point(class_scope:mascot.GetAttributeListMessage)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  mutable int _cached_size_;
  friend struct ::protobuf_device_2eproto::TableStruct;
  friend void ::protobuf_device_2eproto::InitDefaultsGetAttributeListMessageImpl();
};
// -------------------------------------------------------------------

class GetCommandListMessage : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.GetCommandListMessage) */ {
 public:
  GetCommandListMessage();
  virtual ~GetCommandListMessage();

  GetCommandListMessage(const GetCommandListMessage& from);

  inline GetCommandListMessage& operator=(const GetCommandListMessage& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  GetCommandListMessage(GetCommandListMessage&& from) noexcept
    : GetCommandListMessage() {
    *this = ::std::move(from);
  }

  inline GetCommandListMessage& operator=(GetCommandListMessage&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const GetCommandListMessage& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const GetCommandListMessage* internal_default_instance() {
    return reinterpret_cast<const GetCommandListMessage*>(
               &_GetCommandListMessage_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    1;

  void Swap(GetCommandListMessage* other);
  friend void swap(GetCommandListMessage& a, GetCommandListMessage& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline GetCommandListMessage* New() const PROTOBUF_FINAL { return New(NULL); }

  GetCommandListMessage* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const GetCommandListMessage& from);
  void MergeFrom(const GetCommandListMessage& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(GetCommandListMessage* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // @@protoc_insertion_point(class_scope:mascot.GetCommandListMessage)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  mutable int _cached_size_;
  friend struct ::protobuf_device_2eproto::TableStruct;
  friend void ::protobuf_device_2eproto::InitDefaultsGetCommandListMessageImpl();
};
// -------------------------------------------------------------------

class DeviceAttributeDescription : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.DeviceAttributeDescription) */ {
 public:
  DeviceAttributeDescription();
  virtual ~DeviceAttributeDescription();

  DeviceAttributeDescription(const DeviceAttributeDescription& from);

  inline DeviceAttributeDescription& operator=(const DeviceAttributeDescription& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  DeviceAttributeDescription(DeviceAttributeDescription&& from) noexcept
    : DeviceAttributeDescription() {
    *this = ::std::move(from);
  }

  inline DeviceAttributeDescription& operator=(DeviceAttributeDescription&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const DeviceAttributeDescription& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const DeviceAttributeDescription* internal_default_instance() {
    return reinterpret_cast<const DeviceAttributeDescription*>(
               &_DeviceAttributeDescription_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    2;

  void Swap(DeviceAttributeDescription* other);
  friend void swap(DeviceAttributeDescription& a, DeviceAttributeDescription& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline DeviceAttributeDescription* New() const PROTOBUF_FINAL { return New(NULL); }

  DeviceAttributeDescription* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const DeviceAttributeDescription& from);
  void MergeFrom(const DeviceAttributeDescription& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(DeviceAttributeDescription* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // string name = 1;
  void clear_name();
  static const int kNameFieldNumber = 1;
  const ::std::string& name() const;
  void set_name(const ::std::string& value);
  #if LANG_CXX11
  void set_name(::std::string&& value);
  #endif
  void set_name(const char* value);
  void set_name(const char* value, size_t size);
  ::std::string* mutable_name();
  ::std::string* release_name();
  void set_allocated_name(::std::string* name);

  // .mascot.CmdArgType dataType = 2;
  void clear_datatype();
  static const int kDataTypeFieldNumber = 2;
  ::mascot::CmdArgType datatype() const;
  void set_datatype(::mascot::CmdArgType value);

  // bool writable = 3;
  void clear_writable();
  static const int kWritableFieldNumber = 3;
  bool writable() const;
  void set_writable(bool value);

  // @@protoc_insertion_point(class_scope:mascot.DeviceAttributeDescription)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::internal::ArenaStringPtr name_;
  int datatype_;
  bool writable_;
  mutable int _cached_size_;
  friend struct ::protobuf_device_2eproto::TableStruct;
  friend void ::protobuf_device_2eproto::InitDefaultsDeviceAttributeDescriptionImpl();
};
// -------------------------------------------------------------------

class AttributeListReply : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.AttributeListReply) */ {
 public:
  AttributeListReply();
  virtual ~AttributeListReply();

  AttributeListReply(const AttributeListReply& from);

  inline AttributeListReply& operator=(const AttributeListReply& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  AttributeListReply(AttributeListReply&& from) noexcept
    : AttributeListReply() {
    *this = ::std::move(from);
  }

  inline AttributeListReply& operator=(AttributeListReply&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const AttributeListReply& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const AttributeListReply* internal_default_instance() {
    return reinterpret_cast<const AttributeListReply*>(
               &_AttributeListReply_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    3;

  void Swap(AttributeListReply* other);
  friend void swap(AttributeListReply& a, AttributeListReply& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline AttributeListReply* New() const PROTOBUF_FINAL { return New(NULL); }

  AttributeListReply* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const AttributeListReply& from);
  void MergeFrom(const AttributeListReply& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(AttributeListReply* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // repeated .mascot.DeviceAttributeDescription attributes = 1;
  int attributes_size() const;
  void clear_attributes();
  static const int kAttributesFieldNumber = 1;
  const ::mascot::DeviceAttributeDescription& attributes(int index) const;
  ::mascot::DeviceAttributeDescription* mutable_attributes(int index);
  ::mascot::DeviceAttributeDescription* add_attributes();
  ::google::protobuf::RepeatedPtrField< ::mascot::DeviceAttributeDescription >*
      mutable_attributes();
  const ::google::protobuf::RepeatedPtrField< ::mascot::DeviceAttributeDescription >&
      attributes() const;

  // @@protoc_insertion_point(class_scope:mascot.AttributeListReply)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::RepeatedPtrField< ::mascot::DeviceAttributeDescription > attributes_;
  mutable int _cached_size_;
  friend struct ::protobuf_device_2eproto::TableStruct;
  friend void ::protobuf_device_2eproto::InitDefaultsAttributeListReplyImpl();
};
// -------------------------------------------------------------------

class DeviceCommandDescription_ParametersEntry_DoNotUse : public ::google::protobuf::internal::MapEntry<DeviceCommandDescription_ParametersEntry_DoNotUse, 
    ::std::string, ::mascot::CmdArgType,
    ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
    ::google::protobuf::internal::WireFormatLite::TYPE_ENUM,
    0 > {
public:
  typedef ::google::protobuf::internal::MapEntry<DeviceCommandDescription_ParametersEntry_DoNotUse, 
    ::std::string, ::mascot::CmdArgType,
    ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
    ::google::protobuf::internal::WireFormatLite::TYPE_ENUM,
    0 > SuperType;
  DeviceCommandDescription_ParametersEntry_DoNotUse();
  DeviceCommandDescription_ParametersEntry_DoNotUse(::google::protobuf::Arena* arena);
  void MergeFrom(const DeviceCommandDescription_ParametersEntry_DoNotUse& other);
  static const DeviceCommandDescription_ParametersEntry_DoNotUse* internal_default_instance() { return reinterpret_cast<const DeviceCommandDescription_ParametersEntry_DoNotUse*>(&_DeviceCommandDescription_ParametersEntry_DoNotUse_default_instance_); }
  void MergeFrom(const ::google::protobuf::Message& other) PROTOBUF_FINAL;
  ::google::protobuf::Metadata GetMetadata() const;
};

// -------------------------------------------------------------------

class DeviceCommandDescription_ReturnValuesEntry_DoNotUse : public ::google::protobuf::internal::MapEntry<DeviceCommandDescription_ReturnValuesEntry_DoNotUse, 
    ::std::string, ::mascot::CmdArgType,
    ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
    ::google::protobuf::internal::WireFormatLite::TYPE_ENUM,
    0 > {
public:
  typedef ::google::protobuf::internal::MapEntry<DeviceCommandDescription_ReturnValuesEntry_DoNotUse, 
    ::std::string, ::mascot::CmdArgType,
    ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
    ::google::protobuf::internal::WireFormatLite::TYPE_ENUM,
    0 > SuperType;
  DeviceCommandDescription_ReturnValuesEntry_DoNotUse();
  DeviceCommandDescription_ReturnValuesEntry_DoNotUse(::google::protobuf::Arena* arena);
  void MergeFrom(const DeviceCommandDescription_ReturnValuesEntry_DoNotUse& other);
  static const DeviceCommandDescription_ReturnValuesEntry_DoNotUse* internal_default_instance() { return reinterpret_cast<const DeviceCommandDescription_ReturnValuesEntry_DoNotUse*>(&_DeviceCommandDescription_ReturnValuesEntry_DoNotUse_default_instance_); }
  void MergeFrom(const ::google::protobuf::Message& other) PROTOBUF_FINAL;
  ::google::protobuf::Metadata GetMetadata() const;
};

// -------------------------------------------------------------------

class DeviceCommandDescription : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.DeviceCommandDescription) */ {
 public:
  DeviceCommandDescription();
  virtual ~DeviceCommandDescription();

  DeviceCommandDescription(const DeviceCommandDescription& from);

  inline DeviceCommandDescription& operator=(const DeviceCommandDescription& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  DeviceCommandDescription(DeviceCommandDescription&& from) noexcept
    : DeviceCommandDescription() {
    *this = ::std::move(from);
  }

  inline DeviceCommandDescription& operator=(DeviceCommandDescription&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const DeviceCommandDescription& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const DeviceCommandDescription* internal_default_instance() {
    return reinterpret_cast<const DeviceCommandDescription*>(
               &_DeviceCommandDescription_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    6;

  void Swap(DeviceCommandDescription* other);
  friend void swap(DeviceCommandDescription& a, DeviceCommandDescription& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline DeviceCommandDescription* New() const PROTOBUF_FINAL { return New(NULL); }

  DeviceCommandDescription* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const DeviceCommandDescription& from);
  void MergeFrom(const DeviceCommandDescription& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(DeviceCommandDescription* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------


  // accessors -------------------------------------------------------

  // map<string, .mascot.CmdArgType> parameters = 2;
  int parameters_size() const;
  void clear_parameters();
  static const int kParametersFieldNumber = 2;
  const ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >&
      parameters() const;
  ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >*
      mutable_parameters();

  // map<string, .mascot.CmdArgType> returnValues = 3;
  int returnvalues_size() const;
  void clear_returnvalues();
  static const int kReturnValuesFieldNumber = 3;
  const ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >&
      returnvalues() const;
  ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >*
      mutable_returnvalues();

  // string name = 1;
  void clear_name();
  static const int kNameFieldNumber = 1;
  const ::std::string& name() const;
  void set_name(const ::std::string& value);
  #if LANG_CXX11
  void set_name(::std::string&& value);
  #endif
  void set_name(const char* value);
  void set_name(const char* value, size_t size);
  ::std::string* mutable_name();
  ::std::string* release_name();
  void set_allocated_name(::std::string* name);

  // @@protoc_insertion_point(class_scope:mascot.DeviceCommandDescription)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::internal::MapField<
      DeviceCommandDescription_ParametersEntry_DoNotUse,
      ::std::string, ::mascot::CmdArgType,
      ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
      ::google::protobuf::internal::WireFormatLite::TYPE_ENUM,
      0 > parameters_;
  ::google::protobuf::internal::MapField<
      DeviceCommandDescription_ReturnValuesEntry_DoNotUse,
      ::std::string, ::mascot::CmdArgType,
      ::google::protobuf::internal::WireFormatLite::TYPE_STRING,
      ::google::protobuf::internal::WireFormatLite::TYPE_ENUM,
      0 > returnvalues_;
  ::google::protobuf::internal::ArenaStringPtr name_;
  mutable int _cached_size_;
  friend struct ::protobuf_device_2eproto::TableStruct;
  friend void ::protobuf_device_2eproto::InitDefaultsDeviceCommandDescriptionImpl();
};
// -------------------------------------------------------------------

class CommandListReply : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.CommandListReply) */ {
 public:
  CommandListReply();
  virtual ~CommandListReply();

  CommandListReply(const CommandListReply& from);

  inline CommandListReply& operator=(const CommandListReply& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  CommandListReply(CommandListReply&& from) noexcept
    : CommandListReply() {
    *this = ::std::move(from);
  }

  inline CommandListReply& operator=(CommandListReply&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const CommandListReply& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const CommandListReply* internal_default_instance() {
    return reinterpret_cast<const CommandListReply*>(
               &_CommandListReply_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    7;

  void Swap(CommandListReply* other);
  friend void swap(CommandListReply& a, CommandListReply& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline CommandListReply* New() const PROTOBUF_FINAL { return New(NULL); }

  CommandListReply* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const CommandListReply& from);
  void MergeFrom(const CommandListReply& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(CommandListReply* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // repeated .mascot.DeviceCommandDescription commands = 1;
  int commands_size() const;
  void clear_commands();
  static const int kCommandsFieldNumber = 1;
  const ::mascot::DeviceCommandDescription& commands(int index) const;
  ::mascot::DeviceCommandDescription* mutable_commands(int index);
  ::mascot::DeviceCommandDescription* add_commands();
  ::google::protobuf::RepeatedPtrField< ::mascot::DeviceCommandDescription >*
      mutable_commands();
  const ::google::protobuf::RepeatedPtrField< ::mascot::DeviceCommandDescription >&
      commands() const;

  // @@protoc_insertion_point(class_scope:mascot.CommandListReply)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::RepeatedPtrField< ::mascot::DeviceCommandDescription > commands_;
  mutable int _cached_size_;
  friend struct ::protobuf_device_2eproto::TableStruct;
  friend void ::protobuf_device_2eproto::InitDefaultsCommandListReplyImpl();
};
// ===================================================================


// ===================================================================

#ifdef __GNUC__
  #pragma GCC diagnostic push
  #pragma GCC diagnostic ignored "-Wstrict-aliasing"
#endif  // __GNUC__
// GetAttributeListMessage

// -------------------------------------------------------------------

// GetCommandListMessage

// -------------------------------------------------------------------

// DeviceAttributeDescription

// string name = 1;
inline void DeviceAttributeDescription::clear_name() {
  name_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& DeviceAttributeDescription::name() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttributeDescription.name)
  return name_.GetNoArena();
}
inline void DeviceAttributeDescription::set_name(const ::std::string& value) {
  
  name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.DeviceAttributeDescription.name)
}
#if LANG_CXX11
inline void DeviceAttributeDescription::set_name(::std::string&& value) {
  
  name_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.DeviceAttributeDescription.name)
}
#endif
inline void DeviceAttributeDescription::set_name(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.DeviceAttributeDescription.name)
}
inline void DeviceAttributeDescription::set_name(const char* value, size_t size) {
  
  name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.DeviceAttributeDescription.name)
}
inline ::std::string* DeviceAttributeDescription::mutable_name() {
  
  // @@protoc_insertion_point(field_mutable:mascot.DeviceAttributeDescription.name)
  return name_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* DeviceAttributeDescription::release_name() {
  // @@protoc_insertion_point(field_release:mascot.DeviceAttributeDescription.name)
  
  return name_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void DeviceAttributeDescription::set_allocated_name(::std::string* name) {
  if (name != NULL) {
    
  } else {
    
  }
  name_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), name);
  // @@protoc_insertion_point(field_set_allocated:mascot.DeviceAttributeDescription.name)
}

// .mascot.CmdArgType dataType = 2;
inline void DeviceAttributeDescription::clear_datatype() {
  datatype_ = 0;
}
inline ::mascot::CmdArgType DeviceAttributeDescription::datatype() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttributeDescription.dataType)
  return static_cast< ::mascot::CmdArgType >(datatype_);
}
inline void DeviceAttributeDescription::set_datatype(::mascot::CmdArgType value) {
  
  datatype_ = value;
  // @@protoc_insertion_point(field_set:mascot.DeviceAttributeDescription.dataType)
}

// bool writable = 3;
inline void DeviceAttributeDescription::clear_writable() {
  writable_ = false;
}
inline bool DeviceAttributeDescription::writable() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttributeDescription.writable)
  return writable_;
}
inline void DeviceAttributeDescription::set_writable(bool value) {
  
  writable_ = value;
  // @@protoc_insertion_point(field_set:mascot.DeviceAttributeDescription.writable)
}

// -------------------------------------------------------------------

// AttributeListReply

// repeated .mascot.DeviceAttributeDescription attributes = 1;
inline int AttributeListReply::attributes_size() const {
  return attributes_.size();
}
inline void AttributeListReply::clear_attributes() {
  attributes_.Clear();
}
inline const ::mascot::DeviceAttributeDescription& AttributeListReply::attributes(int index) const {
  // @@protoc_insertion_point(field_get:mascot.AttributeListReply.attributes)
  return attributes_.Get(index);
}
inline ::mascot::DeviceAttributeDescription* AttributeListReply::mutable_attributes(int index) {
  // @@protoc_insertion_point(field_mutable:mascot.AttributeListReply.attributes)
  return attributes_.Mutable(index);
}
inline ::mascot::DeviceAttributeDescription* AttributeListReply::add_attributes() {
  // @@protoc_insertion_point(field_add:mascot.AttributeListReply.attributes)
  return attributes_.Add();
}
inline ::google::protobuf::RepeatedPtrField< ::mascot::DeviceAttributeDescription >*
AttributeListReply::mutable_attributes() {
  // @@protoc_insertion_point(field_mutable_list:mascot.AttributeListReply.attributes)
  return &attributes_;
}
inline const ::google::protobuf::RepeatedPtrField< ::mascot::DeviceAttributeDescription >&
AttributeListReply::attributes() const {
  // @@protoc_insertion_point(field_list:mascot.AttributeListReply.attributes)
  return attributes_;
}

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// DeviceCommandDescription

// string name = 1;
inline void DeviceCommandDescription::clear_name() {
  name_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& DeviceCommandDescription::name() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceCommandDescription.name)
  return name_.GetNoArena();
}
inline void DeviceCommandDescription::set_name(const ::std::string& value) {
  
  name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.DeviceCommandDescription.name)
}
#if LANG_CXX11
inline void DeviceCommandDescription::set_name(::std::string&& value) {
  
  name_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.DeviceCommandDescription.name)
}
#endif
inline void DeviceCommandDescription::set_name(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.DeviceCommandDescription.name)
}
inline void DeviceCommandDescription::set_name(const char* value, size_t size) {
  
  name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.DeviceCommandDescription.name)
}
inline ::std::string* DeviceCommandDescription::mutable_name() {
  
  // @@protoc_insertion_point(field_mutable:mascot.DeviceCommandDescription.name)
  return name_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* DeviceCommandDescription::release_name() {
  // @@protoc_insertion_point(field_release:mascot.DeviceCommandDescription.name)
  
  return name_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void DeviceCommandDescription::set_allocated_name(::std::string* name) {
  if (name != NULL) {
    
  } else {
    
  }
  name_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), name);
  // @@protoc_insertion_point(field_set_allocated:mascot.DeviceCommandDescription.name)
}

// map<string, .mascot.CmdArgType> parameters = 2;
inline int DeviceCommandDescription::parameters_size() const {
  return parameters_.size();
}
inline void DeviceCommandDescription::clear_parameters() {
  parameters_.Clear();
}
inline const ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >&
DeviceCommandDescription::parameters() const {
  // @@protoc_insertion_point(field_map:mascot.DeviceCommandDescription.parameters)
  return parameters_.GetMap();
}
inline ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >*
DeviceCommandDescription::mutable_parameters() {
  // @@protoc_insertion_point(field_mutable_map:mascot.DeviceCommandDescription.parameters)
  return parameters_.MutableMap();
}

// map<string, .mascot.CmdArgType> returnValues = 3;
inline int DeviceCommandDescription::returnvalues_size() const {
  return returnvalues_.size();
}
inline void DeviceCommandDescription::clear_returnvalues() {
  returnvalues_.Clear();
}
inline const ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >&
DeviceCommandDescription::returnvalues() const {
  // @@protoc_insertion_point(field_map:mascot.DeviceCommandDescription.returnValues)
  return returnvalues_.GetMap();
}
inline ::google::protobuf::Map< ::std::string, ::mascot::CmdArgType >*
DeviceCommandDescription::mutable_returnvalues() {
  // @@protoc_insertion_point(field_mutable_map:mascot.DeviceCommandDescription.returnValues)
  return returnvalues_.MutableMap();
}

// -------------------------------------------------------------------

// CommandListReply

// repeated .mascot.DeviceCommandDescription commands = 1;
inline int CommandListReply::commands_size() const {
  return commands_.size();
}
inline void CommandListReply::clear_commands() {
  commands_.Clear();
}
inline const ::mascot::DeviceCommandDescription& CommandListReply::commands(int index) const {
  // @@protoc_insertion_point(field_get:mascot.CommandListReply.commands)
  return commands_.Get(index);
}
inline ::mascot::DeviceCommandDescription* CommandListReply::mutable_commands(int index) {
  // @@protoc_insertion_point(field_mutable:mascot.CommandListReply.commands)
  return commands_.Mutable(index);
}
inline ::mascot::DeviceCommandDescription* CommandListReply::add_commands() {
  // @@protoc_insertion_point(field_add:mascot.CommandListReply.commands)
  return commands_.Add();
}
inline ::google::protobuf::RepeatedPtrField< ::mascot::DeviceCommandDescription >*
CommandListReply::mutable_commands() {
  // @@protoc_insertion_point(field_mutable_list:mascot.CommandListReply.commands)
  return &commands_;
}
inline const ::google::protobuf::RepeatedPtrField< ::mascot::DeviceCommandDescription >&
CommandListReply::commands() const {
  // @@protoc_insertion_point(field_list:mascot.CommandListReply.commands)
  return commands_;
}

#ifdef __GNUC__
  #pragma GCC diagnostic pop
#endif  // __GNUC__
// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------


// @@protoc_insertion_point(namespace_scope)

}  // namespace mascot

// @@protoc_insertion_point(global_scope)

#endif  // PROTOBUF_device_2eproto__INCLUDED
